<?php
set_time_limit(5000);
ini_set("memory_limit", "4096M");

	function sendFile($filename)
	{
		$dir = $filename;
		if ( !stristr( $filename, ".zip" ) ) $filename .= ".zip";
		if (!class_exists('ZipArchive')):
		    trigger_error('ZipArchive Class does not exist', E_USER_ERROR);
		endif;
		$z = new ZipArchive();
		$uid = uniqid();
		$zfn="tmp/".$uid;
		if ($z->open($zfn, ZIPARCHIVE::CREATE) !== TRUE):
		    trigger_error('Unable to create zip archive', E_USER_ERROR);
		endif;

		$out="Fichier téléchargé depuis ".$_SERVER["HTTP_REFERER"]."\nContenu : \n";
		$d = dir("../".$dir);
		while(false !== ($e = $d->read()))
		{
			if(!is_dir($e) && $e!="index.php" && $e!="tn")
			{
				$f=realpath (dirname ( __FILE__ ) . "/../".$dir."/".$e);
				if (file_exists($f)) $z->addFile($f, $e);
				else die("Fichier $f manquant");
				$out.=$e."\n";
			}
		}
		$z->addFromString ( "index.txt" , $out );
		$z->close();

		header('Last-Modified: '.gmdate('D, d M Y H:i:s', filemtime($zfm)).' GMT',  TRUE, 200);
		header('Cache-Control: no-cache', TRUE);
		header('Pragma: Public', TRUE);
		header('Expires: ' . gmdate('D, d M Y H:i:s', time()) . ' GMT', TRUE);
		header('Content-Length: '.filesize($zfn), TRUE);
		header('Content-disposition: attachment; filename='.$filename, TRUE);
		header('Content-Type: application/octet-stream', TRUE);

		ob_start();
		readfile($zfn);
		unlink($zfn);
		ob_end_flush();
		exit;

	}
$ref=$_SERVER["HTTP_REFERER"];
if (!empty($ref) && $ref!="include")
{
	$str=explode ("/", $ref);
	$filename=$str[count($str)-2];
	sendFile($filename);
}
